/*
 * Java bytecode manipulation with ASM toolkit
 * Copyright (c) 2004, Eugene Kuleshov
 *
 * This library is free software; you can redistribute it and/or            
 * modify it under the terms of the GNU Lesser General Public               
 * License as published by the Free Software Foundation; either             
 * version 2.1 of the License, or (at your option) any later version.       
 *                                                                          
 * This library is distributed in the hope that it will be useful,          
 * but WITHOUT ANY WARRANTY; without even the implied warranty of           
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        
 * Lesser General Public License for more details.                          
 *                                                                          
 * You should have received a copy of the GNU Lesser General Public         
 * License along with this library; if not, write to the Free Software      
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package asm1;

import java.util.ArrayList;


public class Counter2 implements Notifier, Counter {
  private int n;
  private ArrayList __lst = new ArrayList();
    
  public void increment() {
    notify( "increment()");
    n++;
  }

  public int count() {
    notify( "count()");
    return n;
  }

  // Listener implementation
  public void notify( String msg) {
    for( int i = 0; i<__lst.size(); i++) {
      ((Listener)__lst.get(i)).notify(this, msg);
    }
  }

  public void addListener( Listener listener) {
    __lst.add( listener);
  }

}
