/*
 * Manage Java 5 annotations using ASM toolkit
 * Copyright (c) 2004, Eugene Kuleshov
 *
 * This library is free software; you can redistribute it and/or            
 * modify it under the terms of the GNU Lesser General Public               
 * License as published by the Free Software Foundation; either             
 * version 2.1 of the License, or (at your option) any later version.       
 *                                                                          
 * This library is distributed in the hope that it will be useful,          
 * but WITHOUT ANY WARRANTY; without even the implied warranty of           
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        
 * Lesser General Public License for more details.                          
 *                                                                          
 * You should have received a copy of the GNU Lesser General Public         
 * License along with this library; if not, write to the Free Software      
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package asm2;

import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.util.List;


public class AnnotatedClass {
  private AnnReader r;

  public AnnotatedClass(Class c) {
    try {
      URL u = c.getResource("/"+
          c.getName().replace('.', '/')+".class");
      r = new AnnReader(u.openStream());
    } catch(IOException ex) {
      throw new RuntimeException(ex.toString());
    }
  }
  
  public AnnotatedClass(InputStream is) {
    try {
      r = new AnnReader(is);
    } catch(IOException ex) {
      throw new RuntimeException(ex.toString());
    }
  }

  public Ann[] getAnnotations() {
    List anns = r.getClassAnnotations();
    return (Ann[]) anns.toArray(new Ann[0]);
  }

  public Ann getAnnotation(Class c) {
    throw new RuntimeException("Not implemented");
  }

  public boolean isAnnotationPresent(Class c) {
    throw new RuntimeException("Not implemented");
  }
  
  public AnnotatedMethod[] getMethods() {
    throw new RuntimeException("Not implemented");
  }
  
  public AnnotatedField[] getFields() {
    throw new RuntimeException("Not implemented");
  }
  
}

