/*
 * Manage Java 5 annotations using ASM toolkit
 * Copyright (c) 2004, Eugene Kuleshov
 *
 * This library is free software; you can redistribute it and/or            
 * modify it under the terms of the GNU Lesser General Public               
 * License as published by the Free Software Foundation; either             
 * version 2.1 of the License, or (at your option) any later version.       
 *                                                                          
 * This library is distributed in the hope that it will be useful,          
 * but WITHOUT ANY WARRANTY; without even the implied warranty of           
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        
 * Lesser General Public License for more details.                          
 *                                                                          
 * You should have received a copy of the GNU Lesser General Public         
 * License along with this library; if not, write to the Free Software      
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package asm2;

import junit.framework.TestCase;


public class AnnotatedClassTest extends TestCase {

  public void test() throws Exception {
    Class c = Calculator2.class;    
    AnnotatedClass ac = new AnnotatedClass(c);
    
    Ann[] anns = ac.getAnnotations();

    assertEquals( 1, anns.length);
    assertTrue( anns[ 0] instanceof Marker);
    
    Marker m = ( Marker) anns[ 0];
    String value = m.value();
    assertEquals( "Class", value);
  }
  
}

